/*
 * aodv.configuration.h
 *
 *  Created on: 21.05.2009
 *      Author: Janos
 */

#ifndef AODV_CONFIGURATION_H_
#define AODV_CONFIGURATION_H_

#include <ScatterWeb.System.h>


#define ACTIVE_ROUTE_TIMEOUT 				(3000) 			// Milliseconds
#define RREQ_RETRIES 						(2)
#define ALLOWED_HELLO_LOSS 					(2)
#define HELLO_INTERVAL 						(1000) 			// Milliseconds
#define LOCAL_ADD_TTL 						(2)
#define NET_DIAMETER 						(35)
#define NODE_TRAVERSAL_TIME 				(40) 			// Milliseconds
#define RERR_RATELIMIT 						(10)
#define RREQ_RATELIMIT 						(10)
#define TIMEOUT_BUFFER 						(2)
#define TTL_START 							(1)
#define TTL_INCREMENT 						(2)
#define TTL_THRESHOLD 						(7)
#define DELETE_PERIOD 						(5 * ACTIVE_ROUTE_TIMEOUT)		// see note
#define MAX_REPAIR_TTL 						(NET_DIAMETER / 3)
#define MY_ROUTE_TIMEOUT 					(2 * ACTIVE_ROUTE_TIMEOUT)
#define NET_TRAVERSAL_TIME 					(2 * NODE_TRAVERSAL_TIME * NET_DIAMETER)
#define NEXT_HOP_WAIT 						(NODE_TRAVERSAL_TIME + 10)
#define PATH_DISCOVERY_TIME 				(2 * NET_TRAVERSAL_TIME)
#define RING_TRAVERSAL_TIME(TTL_VALUE) 		(2 * NODE_TRAVERSAL_TIME * (TTL_VALUE + TIMEOUT_BUFFER))
#define BLACKLIST_TIMEOUT 					(RREQ_RETRIES * NET_TRAVERSAL_TIME)

/**
 * Returns the next incemented Request-ID
 */
uint16_t getNextRequestID();

/**
 * Returns this nodes destination sequence number.
 */
uint16_t getOwnDestinationSequenceNumber();

/**
 * Increases this nodes destination sequence number and returns
 * the increased value.
 */
uint16_t increaseOwnDestinationSequenceNumber();

#endif /* AODV_CONFIGURATION_H_ */
