/*
 * aodv.test.commands.h
 *
 *  Created on: 14.07.2009
 *      Author: Janos
 */

#ifndef AODV_TEST_COMMANDS_H_
#define AODV_TEST_COMMANDS_H_


#include <ScatterWeb.System.h>
#include <ScatterWeb.CC1020.h>
#include <ScatterWeb.Cmd.internal.h>
#include <string.h>

#include "log.h"

#include "controller.basicIO.h"
#include "controller.trafficGenerator.h"
#include "controller.netTypes.h"

#include "aodv.messageTypes.h"
#include "aodv.routing.h"
#include "aodv.interface.h"

#define AODV_TEST_APPLICATION 		(0x2AAD)

enum AODV_TEST_PACKET_TYPE {
	RESET_CHAIN
	, TEST_1A
	, TEST_2A
	, TEST_3A
};

typedef struct aodv_test_packet_s {
	enum AODV_TEST_PACKET_TYPE type;
	uint8_t forward_hopCount;
	uint8_t reverse_hopCount;
	bool isForwardDirection;
} aodv_test_packet_t;

void tests_initRandom(void);

uint16_t rand_n(uint16_t max);

uint32_t *startTimer(void);
uint32_t stopTimer(uint32_t *timer);

void processTestPacket(const void *data, const uint16_t size);
void processTestAODVPacket(aodv_dataPacket_t *dataPacket);

#endif /* AODV_TEST_COMMANDS_H_ */
