/*
 * aodv.log.h
 *
 *  Created on: 28.06.2009
 *      Author: Janos
 */

#ifndef AODV_LOG_H_
#define AODV_LOG_H_

#include <string.h>

#include <ScatterWeb.System.h>

#include "aodv.test.configuration.h"


#define LOG_SPACES 		30
unsigned int i_log_counter;
signed int j_log_compare;

extern bool bDontLog;

#define spaces(key_len) j_log_compare = ((LOG_SPACES - 3) - key_len); \
	if (j_log_compare > 0) { for(i_log_counter = 0; i_log_counter < (unsigned) j_log_compare; i_log_counter++) { printf(" "); } } \
	else {printf("\r\n"); for(i_log_counter = 0; i_log_counter < LOG_SPACES; i_log_counter++) { printf(" "); } }


#define _STRING(string) #string
#define STRING(string) 	_STRING(string)

#ifndef DONT_LOG
#ifdef LOG_CONDITIONAL
#define log(key, text...) if (!bDontLog) { printf("[%s]:", key); spaces(strlen(key)); printf(text); printf("\r\n"); }
#define logm(text...) if (!bDontLog) { spaces(-3); printf(text); printf("\r\n"); }
#define logsep() if (!bDontLog) { printf("===================================================================\r\n"); }
#else
#define log(key, text...) printf("[%s]:", key); spaces(strlen(key)); printf(text); printf("\r\n")
#define logm(text...) spaces(-3); printf(text); printf("\r\n");
#define logsep() printf("===================================================================\r\n")
#endif
#else

#define log(key, text...);
#define logm(text...);
#define logsep();

#endif

#define testlog(key, text...) printf("[%s]:", key); spaces(strlen(key)); printf(text); printf("\r\n")

#define testlogm(text...) spaces(-3); printf(text); printf("\r\n");

#define teststart(testID, name) printf("["STRING(testID)"]======= "name" ============================================================\r\n")
#define testfinish(testID, name) printf("[END OF "STRING(testID)"]======= "name" =====================================================\r\n")
#define testend() printf("===================================================================\r\n")



#endif /* AODV_LOG_H_ */
